const char* get_shortnam(int i)
{
	shortnam *akt;
	akt=shortnames;
	while(akt){
		if(!i) return akt->name;
		i--;
		akt=akt->next;
	}
	return("???");
}

void readErrorText(const char *name)
{
	char* text;
	FILE *src;
	struct stat st;
	int r;
	r=stat(name,&st);
	text=(char*) malloc(st.st_size+4);
	src=fopen(name,"r");
	if(!src) return;
	r=fread(text,st.st_size,1,src);
	fclose(src);
	text[st.st_size]=0;
	output->value(text);
	remove(name);
	free(text);
}

void cb_fuse_op(Fl_Widget *w,void *v)
{
	FILE *f;
	char st1[2048];
	long int op;
	op=(long int)v;
	int c,r;
	const char ops[]="rwv";
	sprintf(st1,"%s -c %s -p %s -P %s %s",
							ui->dude_location->value(),
							ui->programmer->value(),
							get_shortnam(ui->device_type->value()),
							ui->dude_port->value(),
							ui->dude_options->value());
	for(c=0;c<cfuseBytes;c++){
		sprintf(st1+strlen(st1)," -U %s:%c:0x%s:m",
						fuses[c].name,
						ops[op],
						fuses[c].input->value());
	}
	strcat(st1," 2>>error.txt");
	f=fopen("error.txt","w");
	if(!f) return;
	fprintf(f,"%s\n",st1);
	fclose(f);
	r=system(st1);
	readErrorText("error.txt");
	if(r) fl_alert("Error %s fuses!",op_names[op]);
	else fl_alert("%s Fuses successful!",op_names[op]);
}

void mem_op(int op,int type,Fl_Input *filename,Fl_Choice *format)
{
	FILE *f;
	char st1[2048];
	const char ops[]="rwv";
	const char fmts[]="air";
	int r=0;
	sprintf(st1,"%s -c %s -p %s -P %s %s -U %s:%c:%s:%c 2>>error.txt",
							ui->dude_location->value(),
							ui->programmer->value(),
							get_shortnam(ui->device_type->value()),
							ui->dude_port->value(),
							ui->dude_options->value(),
							type_short[type],
							ops[op],
							filename->value(),
							fmts[format->value()]
							);
	f=fopen("error.txt","w");
	if(!f) return;
	fprintf(f,"%s\n",st1);
	fclose(f);
	r=system(st1);
	readErrorText("error.txt");
	if(r) fl_alert("Error %s %s!",op_names[op],type_names[type]);
	else fl_alert("%s %s successful!",op_names[op],type_names[type]);
}

void wrConfigfile(const char* name)
{
	FILE *f;
	f=fopen(name,"w");
	if(!f) return;
	fprintf(f,"flashfile=%s\n",ui->flashfile->value());
	fprintf(f,"eepromfile=%s\n",ui->eepromfile->value());
	fprintf(f,"dude_location=%s\n",ui->dude_location->value());
	fprintf(f,"dude_options=%s\n",ui->dude_options->value());
	fprintf(f,"programmer=%s\n",ui->programmer->value());
	fprintf(f,"dude_port=%s\n",ui->dude_port->value());
	fprintf(f,"device_type=%s\n",ui->device_type->text(ui->device_type->value()));
	fclose(f);
}

void rdConfig(char *param)
{
	char *cp;
	cp=strchr(param,'=');
	if(!cp) return;
	*cp=0;
	cp++;
	if(!strcmp(param,"flashfile")){
		ui->flashfile->value(cp);
		return;
	}
	if(!strcmp(param,"eepromfile")){
		ui->eepromfile->value(cp);
		return;
	}
	if(!strcmp(param,"dude_location")){
		ui->dude_location->value(cp);
		return;
	}
	if(!strcmp(param,"dude_options")){
		ui->dude_options->value(cp);
		return;
	}
	if(!strcmp(param,"dude_port")){
		ui->dude_port->value(cp);
		return;
	}
	if(!strcmp(param,"programmer")){
		ui->programmer->value(cp);
		return;
	}
	if(!strcmp(param,"device_type")){
		strcpy(device,cp);
		return;
	}
	printf("Unkonwn Parameter %s (value=%s)\n",param,cp);
}

void rdConfigfile(const char* name)
{
	FILE *f;
	char st1[2048],*cp;
	f=fopen(name,"r");
	if(!f) return;
	while(fgets(st1,2000,f)){
		if(cp=strchr(st1,'\n')) *cp=0;
		rdConfig(st1);
	}
	fclose(f);
}

void readProgrammerList()
{
	char st1[2048],*cp;
	FILE *f;
	int r;
	sprintf(st1,"%s -c? 2>error.txt",ui->dude_location->value());
	r=system(st1);
	f=fopen("error.txt","r");
	if(!f) return;
	ui->programmer->clear();
	cp=fgets(st1,200,f);
	cp=fgets(st1,200,f);
	while(fgets(st1,200,f)){
		if(cp=strchr(st1+2,'\n')) *cp=0;
		if(cp=strchr(st1+2,' ')) *cp=0;
		ui->programmer->add(st1+2);
	}
	fclose(f);
	remove("error.txt");
}


void clean()
{
	group *grp,*next_g;
	option *opt,*next_o;
	rule *rul,*next_r;
	grp=root;
	while(grp){
		opt=grp->first_option;
		while(opt){
			rul=opt->first_rule;
			while(rul){
				next_r=rul->next;
				free(rul);
				rul=next_r;
			}
			next_o=opt->next;
			free(opt);
			opt=next_o;
		}
		next_g=grp->next;
		free(grp);
		grp=next_g;
	}
	root=0;
}

int nextNam(char* longnam, char*shortnam=0)
{
	char st1[2048],*cp1,*cp2;
	while(fgets(st1,2000,config)){
		if(cp1=strstr(st1,"AVR name=")){
			cp1+=10;
			if(!(cp2=strchr(cp1,'"'))) return 0;
			*cp2=0;
			if(shortnam) strcpy(shortnam,cp1);
			cp2++;
			if(cp1=strstr(cp2,"caption=")){
				cp1+=9;
				if(cp2=strchr(cp1,'"')) *cp2=0;
				strcpy(longnam,cp1);
				return 1;
			}
		}
	}
	return 0;	/* Ende */
}

void addFuse(char *bitnam,int bitpos,char* bytenam,int defaultvalue,int mode,char *desc)
{
	int fusebyte=0;
	//printf("%s,%d,%s,%d,%d,%s\n",bitnam,bitpos,bytenam,defaultvalue,mode,desc);
	/* gibt es dieses FuseByte schon? */
	while((fusebyte<cfuseBytes)&&(strcmp(bytenam,fuses[fusebyte].name))) fusebyte++;
	if(strcmp(bytenam,fuses[fusebyte].name)){
		strcpy(fuses[fusebyte].name,bytenam);
		cfuseBytes++;
		//printf("Byte %s zugefügt!\n",bytenam);
	}
	strcpy(fuses[fusebyte].fuseBit[bitpos].name,bitnam);
	strcpy(fuses[fusebyte].fuseBit[bitpos].desc,desc);
	fuses[fusebyte].fuseBit[bitpos].defaultvalue=defaultvalue;
	fuses[fusebyte].fuseBit[bitpos].mode=mode;
}

int srchFuse(char *name, int *fuse, int *bit)
{
	for(int c=0;c<cfuseBytes;c++)
	{
		for(int b=0;b<8;b++){
			if(!strcmp(name,fuses[c].fuseBit[b].name)){
				*fuse=c;
				*bit=b;
				return 1;
			}
		}
	}
	return 0;
}

void readGroup(char* name)
{
	char st1[2048],*cp1,*cp2,*attrib,*value;
	int fuse,bit;
	struct group *neu;
	struct option *neu_opt,*last_opt;
	rule *r_neu,*r_last;
	neu=(struct group*)calloc(sizeof(struct group),1);
	if(!root) root=neu;
	else{
		last->next=neu;
	}
	last=neu;
	strcpy(neu->name,name);
	//printf("Gruppe: %s\n",name);
	while(fgets(st1,2000,config)){
		if(cp1=strchr(st1,'<')){
			cp1++;
			if(*cp1=='/'){
				return;
			}
			if(!strncmp(cp1,"Setting",7)){
				cp2=strstr(cp1,"caption=");
				if(!cp2) return;
				cp2+=9;
				cp1=strchr(cp2,'"');
				if(!cp1) return;
				*cp1=0;
				cp1++;
				//printf("%s\n",cp2);
				neu_opt=(option*) calloc(sizeof(option),1);
				strcpy(neu_opt->name,cp2);
				if(!neu->first_option) neu->first_option=neu_opt;
				else last_opt->next=neu_opt;
				last_opt=neu_opt;
				while(*cp1!='/'){
					while((*cp1==' ')||(*cp1=='\t')) cp1++;
					attrib=cp1;
					cp2=strchr(cp1,'=');
					if(!cp2) return;
					*cp2=0;
					cp2+=2;
					value=cp2;
					cp1=strchr(cp2,'"');
					if(!cp1) return;
					*cp1=0;
					cp1++;
					//printf("attrib=%s value=%s\n",attrib,value);
					if(srchFuse(attrib,&fuse,&bit)){
						//printf("gefunden in fuse %d bit %d\n",fuse,bit);
						r_neu=(rule*) calloc(sizeof(rule),1);
						r_neu->fuse=fuse;
						r_neu->bit=bit;
						r_neu->value=atoi(value);
						if(!(neu_opt->first_rule)) neu_opt->first_rule=r_neu;
						else r_last->next=r_neu;
						r_last=r_neu;
					}
					else printf("Fuse %s nicht gefunden!\n",attrib);
				}
			}
		}
	}
	printf("Dateiende erreicht!\n");
}

void readConf()
{
	int c,groups=0,fuses=0,defaultvalue,mode=0,bitpos;
	char st1[2048],*cp,*cp1,*attrib,*value,bytenam[50],bitnam[50],desc[150];
	/* Config einlesen */
	cfuseBytes=0;
	c=0;
	do{
		if(!fgets(st1,2000,config)) return;
		if(cp=strchr(st1,'<')){
			cp++;
			if(strstr(cp,"/>")){
				/* Einzeiler */
				if(!strncmp(cp,"Fuse ",5)){
					cp+=5;
					mode=0;
					bitnam[0]=0;
					bytenam[0]=0;
					desc[0]=0;
					bitpos=-1;
					while(value=strchr(cp,'=')){
						*value=0;
						attrib=cp;
						value+=2;
						cp=strchr(value,'"');
						if(!cp) return;
						*cp=0;
						cp+=2;
						//printf("     Attibut=%s, Wert=%s\n",attrib,value);
						if(!strcmp(attrib,"name")) strcpy(bitnam,value);
						if(!strcmp(attrib,"bit")) bitpos=atoi(value);
						if(!strcmp(attrib,"fuseByte")) strcpy(bytenam,value);
						if(!strcmp(attrib,"default")) defaultvalue=atoi(value);
						if(!strcmp(attrib,"desc")) strcpy(desc,value);
						if((!strcmp(attrib,"mode"))&&(!strcmp(value,"expert"))) mode=1;
					}
					addFuse(bitnam,bitpos,bytenam,defaultvalue,mode,desc);
					fuses++;
					};
			}
			else{
				/* Gruppe */
				if(!strncmp(cp,"/AVR",4)){
					printf("%d Fuses, %d Groups gelesen.\n",fuses,groups);
					return;
				}
				if(cp1=strchr(cp,'>')) *cp1=0;
				readGroup(cp);
				groups++;
			}
			}
		}
		while(1);
}

void selFile(Fl_Input *i,const char *title,Fl_Choice *c=0)
{
	char *cp,filter[50];
	strcpy(filter,"*");
	if(!c) strcpy(filter,"avrdude*");
	else{
		if(c->value()==1) strcpy(filter,"*.hex");
		if(c->value()==2) strcpy(filter,"*.{bin,raw}");
	}
	cp=fl_file_chooser(title,filter,i->value(),0);
	if(cp){
		i->value(cp);
		readProgrammerList();
	}
}
